import scala.io.StdIn
import scala.math.pow

case class Complex(re: Double, im: Double) {
  def +(c: Complex) = new Complex(re + c.re, im + c.im)
  def unary_- = new Complex(-re, -im)
  def -(c: Complex) = this + -c
  def *(c: Complex) =
    new Complex(re * c.re - im * c.im, im * c.re + re * c.im)
  def /(c: Complex) = {
    require(c.re != 0 || c.im != 0)
    val d = pow(c.re, 2) + pow(c.im, 2)
    new Complex((re * c.re + im * c.im) / d, (im * c.re - re * c.im) / d)
  }

  override def toString =
    re + (if (im < 0) " - " + -im else " + " + im) + "i"
}

object ComplexNumberOperations {
  def main(args: Array[String]) {
    var is_live = true
    while (is_live) {
      print("Введите действительную часть первого комплексного числа: ")
      val x1 = StdIn.readDouble()
      print("Введите мнимую часть первого комплексного числа: ")
      val y1 = StdIn.readDouble()
      val z1 = new Complex(x1, y1)

      print("Введите действительную часть второго комплексного числа: ")
      val x2 = StdIn.readDouble()
      print("Введите мнимую часть второго комплексного числа: ")
      val y2 = StdIn.readDouble()
      val z2 = new Complex(x2, y2)

      print("Введите операцию для выполнения (+, -, *, /): ")
      val op = StdIn.readLine()

      val result = op match {
        case "+" => z1 + z2
        case "-" => z1 - z2
        case "*" => z1 * z2
        case "/" => z1 / z2
        case _ => throw new IllegalArgumentException("Неверная операция")
      }
      println("Результат: " + result toString)
      is_live = StdIn.readLine("Вы хотите продолжить? (Y/n) ").toLowerCase() == "y"
    }
  }
}
